package org.ahmadsoft.foprocessor.popup.actions;

import org.ahmadsoft.foprocessor.ui.dialogs.RenderProgress;
import org.apache.fop.render.pcl.PCLRenderer;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public class PclConvertAction implements IObjectActionDelegate {

	private IWorkbenchPart targetPart;
    private ISelection selection;

    /**
	 * Constructor for Action1.
	 */
	public PclConvertAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
        this.targetPart = targetPart;
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
        RenderProgress rp = new RenderProgress(targetPart.getSite().getShell());
        rp.setBlockOnOpen(false);
        rp.open();
        rp.beginRendering(new PCLRenderer(), "pcl", (IStructuredSelection) selection);
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
        this.selection = selection;
	}

}

