package org.ahmadsoft.foprocessor.popup.actions;

import org.ahmadsoft.foprocessor.ui.dialogs.RenderProgress;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import com.multiconn.fop.TIFFRenderer;
import com.multiconn.fop.TIFFRendererFactory;
import com.multiconn.fop.TIFFRendererParams;

public class TiffConvertAction implements IObjectActionDelegate {

	private IWorkbenchPart targetPart;
    private ISelection selection;

    /**
	 * Constructor for Action1.
	 */
	public TiffConvertAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
        this.targetPart = targetPart;
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
        RenderProgress rp = new RenderProgress(targetPart.getSite().getShell());
        rp.setBlockOnOpen(false);
        rp.open();
        
        // Creates TIFFRenderer instance
        //
        TIFFRenderer tiffRenderer = TIFFRendererFactory.newTIFFRenderer();
        
        //Creates render/encode param collection
        //
        TIFFRendererParams params = new TIFFRendererParams();
        
        //Sets up params
        //
        params.setCompression(TIFFRendererParams.COMPRESSION_GROUP3_1D);
        
        //Sets params to the renderer
        //
        tiffRenderer.setRenderParams(params);
        
        rp.beginRendering(tiffRenderer, "tif", (IStructuredSelection) selection);
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
        this.selection = selection;
	}

}

